#pragma once

#include <QString>
#include <QList>
#include <QHash>
#include "ast_basic.h"
#include "libsyntax_global.h"

namespace ast_gen
{
	class TokenAccess;

	/**
	 * @brief 
	 */
	class SyntaxElement {
	public:
		virtual ~SyntaxElement() = default;
		/**
		 * 󶨱ʽʵ.
		 * 
		 * \return ʽʵ
		 */
		virtual std::shared_ptr<const ast_basic::IExprInst> bindExpression() const = 0;

		/**
		 * @brief ͱ
		 * @return
		 */
		virtual int typeMark() const = 0;

		/**
		 * Ƿڵ.
		 *
		 * \return ־
		 */
		virtual bool isAnonymous() const = 0;

		/**
		 * @brief ļ·
		 * @return
		 */
		virtual QString path() const = 0;

		/**
		 * @brief ԪǩԪطؿַ
		 * @return
		 */
		virtual QString signature() const = 0;

		/**
		 * @brief ȡԪ
		 * @return δparentnullptr
		 */
		virtual std::shared_ptr<const SyntaxElement> parent() const = 0;
		/**
		 * @brief øָ.
		 * 
		 * \param inst
		 */
		virtual void setParent(std::shared_ptr<const SyntaxElement> inst) = 0;

		/**
		 * @brief ԪToken
		 * @return
		 */
		virtual QList<std::shared_ptr<const TokenAccess>> selfTokens() const = 0;
	};

	/**
	 * @brief ﷨Ԫʽӿ
	 */
	class LIBSYNTAX_EXPORT ElementAccess {
	private:
		std::shared_ptr<const SyntaxElement> peers;

	public:
		ElementAccess(std::shared_ptr<const SyntaxElement> point);

		std::shared_ptr<const SyntaxElement> element() const;
		QList<std::shared_ptr<const ElementAccess>> children() const;

		/**
		 * @brief ȡԪToken
		 * @return
		 */
		virtual QList<std::shared_ptr<const TokenAccess>> tokens() const;
	};

	class LIBSYNTAX_EXPORT TokenAccess {
	private:
		std::shared_ptr<const ast_gen::SyntaxElement> element_bind;
		std::shared_ptr<const lib_token::IToken> token_store;

	public:
		TokenAccess(std::shared_ptr<const ast_gen::SyntaxElement> elm_inst, std::shared_ptr<const lib_token::IToken> token_inst);
		virtual std::shared_ptr<const ast_gen::SyntaxElement> bind() const;
		virtual std::shared_ptr<const lib_token::IToken> token() const;
	};

	/**
	 * @brief Ԫض
	 */
	class LIBSYNTAX_EXPORT GlobalElement : public SyntaxElement, public ast_basic::ExprsContext {
	private:
		QString names_store;
		QHash<QString, std::shared_ptr<const SyntaxElement>> node_cache;

		std::shared_ptr<ast_basic::IExprInst> bind_exprs = std::make_shared<ast_basic::ExprElement>(nullptr);

	public:
		static GlobalElement* UniquePtr;
		GlobalElement(const QString& name);

		virtual void clearCache();
		virtual std::shared_ptr<const ast_gen::SyntaxElement> appendToCache(std::shared_ptr<const ast_gen::SyntaxElement> named_node);
		/**
		 * @brief ͨڵǩȡڵ
		 * @param signature ȫǩ
		 * @return
		 * @throws ûָڵ׳쳣
		 */
		virtual std::shared_ptr<const ast_gen::SyntaxElement> getNamedNodeBy(int paramType, const QString& signature) const;
		virtual void addChild(std::shared_ptr<ast_gen::SyntaxElement> citem);

		// ParseElement interface
	public:
		virtual int typeMark() const override;
		virtual bool isAnonymous() const override;
		virtual QString signature() const override;
		virtual QString path() const override;
		virtual std::shared_ptr<const SyntaxElement> parent() const override;
		virtual void setParent(std::shared_ptr<const SyntaxElement> inst) override;
		virtual QList<std::shared_ptr<const TokenAccess>> selfTokens() const override;

		// ͨ SyntaxElement ̳
		virtual std::shared_ptr<const ast_basic::IExprInst> bindExpression() const override;
	};
}